module Sync =
  type Server() =
    inherit System.ComponentModel.Component()
    member _.Foo() = 42
    member _.Bar(_:int) = 23

  let main () =
    use server = new Server()
    let x = server.Foo()
    let y = server.Bar(x)
    ignore y

module CPS =
  type Server() =
    inherit System.ComponentModel.Component()
    member _.Foo(k:int -> unit) = k 42
    member _.Bar(_:int, k:int -> unit) = k 23

  let main () =
    use server = new Server()
    server.Foo(fun x ->
      server.Bar(x, fun y ->
        ignore y
      )
    )

module Async =
  type Server() =
    inherit System.ComponentModel.Component()
    member _.Foo() = async { return 42 }
    member _.Bar(_:int) = async { return 23 }

  let main () =
    async {
      use server = new Server()
      let! x = server.Foo()
      let! y = server.Bar(x)
      ignore y
    }
