#r "nuget: FSharp.Data.Adaptive, 1.2.14"

open FSharp.Data.UnitSystems.SI.UnitSymbols
open FSharp.Data.Adaptive

let timeToFloor (height:float<m>) (gravity:float<m/s^2>) : float<s> =
  sqrt (2.0 * height / gravity)
  
let height = cval 10.0<m>
let gravity = cval 9.81<m/s^2>

let dropTime = AVal.map2 timeToFloor height gravity
dropTime.AddCallback(printfn "dropTime = %.3f s")

transact (fun () ->
  height.Value <- 2000.0<m>
  gravity.Value <- 24.79<m/s^2>
)
