type Direction =
  | XParallel
  | YParallel
  | Slanted of float

let directionAngle d =
  match d with
  | XParallel -> 0.0
  | YParallel -> 90.0
  | Slanted v -> v
  
type Measurement =
  {
    Layer     : string
    Position  : float * float
    Direction : Direction
  }
  
let measurementAngle { Direction = d } =
  directionAngle d
  
let myMeasurement =
  {
    Layer     = "1(0)"
    Position  = (4.0, 2.0)
    Direction = XParallel
  }

let myMeasurement' =
  { myMeasurement with
      Direction = Slanted 45.0
  }
