open System
open System.Timers

let timer = new Timer(1000(*ms*), AutoReset = true, Enabled = true)

do
  let event, oddt =
    timer.Elapsed
    |> Event.partition (fun e ->
      e.SignalTime.Second % 2 = 0
    )

  use subscription = event.Subscribe(fun e ->
    Console.WriteLine("EvenSignalTime = {0:u}", e.SignalTime)
  )
  use _ = oddt.Subscribe(fun e ->
    Console.WriteLine("OddSignalTime  = {0:u}", e.SignalTime)
  )

  Threading.Thread.Sleep(3000(*ms*))
  
timer.Dispose()
