module [<WebSharper.JavaScript>] Client
open WebSharper.UI
open WebSharper.UI.Client
open WebSharper.UI.Html

let People =
  ListModel.FromSeq [
    "Alice"
    "Bob"
  ]

let [<WebSharper.SPAEntryPoint>] main () =
  let newName = Var.Create ""
      
  div [] [
    ul [] [
      People.View.DocSeqCached(fun (name: string) ->
        li [] [text name]
      )
    ]
    div [] [
      input [ attr.placeholder "Name"; Attr.Value newName ] []
      button [ on.click (fun _ _ -> People.Add(newName.Value)) ] [ text "Add" ]
      div [] [ text "You are about to add: "; text newName.V ]
    ]
  ]
  |> Doc.RunById "main"
